From d2bc9f3afe23ee04d237ae9f4511fbe59a27ff54 Mon Sep 17 00:00:00 2001
From: Volker Lendecke <vl@samba.org>
Date: Mon, 8 May 2017 21:40:40 +0200
Subject: [PATCH] CVE-2017-7494: rpc_server3: Refuse to open pipe names with /
 inside

Bug: https://bugzilla.samba.org/show_bug.cgi?id=12780

Signed-off-by: Volker Lendecke <vl@samba.org>
Reviewed-by: Jeremy Allison <jra@samba.org>
Reviewed-by: Stefan Metzmacher <metze@samba.org>
---
 source3/rpc_server/srv_pipe.c | 5 +++++
 1 file changed, 5 insertions(+)

diff --git a/source3/rpc_server/srv_pipe.c b/source3/rpc_server/srv_pipe.c
Index: samba-3.6.25/source3/rpc_server/srv_pipe.c
===================================================================
--- samba-3.6.25.orig/source3/rpc_server/srv_pipe.c	2017-06-05 16:33:16.166317633 +0530
+++ samba-3.6.25/source3/rpc_server/srv_pipe.c	2017-06-05 16:36:23.599671132 +0530
@@ -473,6 +473,11 @@
 	const char *pipename = cli_filename;
 	NTSTATUS status;
 
+	if (strchr(pipename, '/')) {
+		DEBUG(1, ("Refusing open on pipe %s\n", pipename));
+		return false;
+	}
+
 	if (strnequal(pipename, "\\PIPE\\", 6)) {
 		pipename += 5;
 	}
